Loading...
Searching...
No Matches
Opm::Elasticity::OrthotropicSym Class Reference

Orthotropic linear elastic material with symmetric constitutive matrix. More...

`#include <materials.hh>`

Inheritance diagram for Opm::Elasticity::OrthotropicSym:

## Public Member Functions

| OrthotropicSym (int ID, const Dune::DynamicVector< double > &Cu)
| Constructor creating a new material.
| ~OrthotropicSym () override
| Empty virtual destructor.
int | numPar () const override
| Returns the number of parameters describing this material.
double | getPar (int ipar=1) const override
| Returns the ipar'th parameter describing this material.
bool | getConstitutiveMatrix (Dune::FieldMatrix< double, 6, 6 > &C, bool invers=false) const override
| Establishes the full constitutive matrix for this material.
bool | getConstitutiveMatrix (Dune::FieldMatrix< double, 3, 3 > &C, bool invers=false) const override
| Establishes the full constitutive matrix for this material.
Public Member Functions inherited from Opm::Elasticity::Material
virtual | ~Material ()
| Empty virtual destructor.
int | num () const
| Returns the external material id.
double | getMassDensity () const
| Returns the mass density of this material.

## Protected Member Functions

std::ostream & | write (std::ostream &os) const override
| Prints the material properties to a stream.
Protected Member Functions inherited from Opm::Elasticity::Material
| Material (int ID=0, double density=0.0)
| Default constructor creating an empty material.

## Additional Inherited Members

Static Public Member Functions inherited from Opm::Elasticity::Material
static Material * | create (int ID, const Dune::DynamicVector< double > &params)
| Creates a material object of a given type.
static Material * | create (int ID, const std::string &file)
| Creates a material object from a rocklist.

## Detailed Description

Orthotropic linear elastic material with symmetric constitutive matrix.

## Constructor & Destructor Documentation

## OrthotropicSym()

Opm::Elasticity::OrthotropicSym::OrthotropicSym | ( | int | ID,
|  | const Dune::DynamicVector< double > & | Cu )

Constructor creating a new material.

Parameters

  [in] | ID | External material number
  [in] | Cu | Upper triangle of the symmetric constitutive matrix

## Member Function Documentation

## getConstitutiveMatrix() [1/2]

bool Opm::Elasticity::OrthotropicSym::getConstitutiveMatrix | ( | Dune::FieldMatrix< double, 3, 3 > & | C,
|  | bool | invers = false ) const

override virtual

Establishes the full constitutive matrix for this material.

Parameters

  [out] | C | The constitutive matrix
  [in] | invers | If true, set up the inverse matrix instead

Implements Opm::Elasticity::Material.

## getConstitutiveMatrix() [2/2]

bool Opm::Elasticity::OrthotropicSym::getConstitutiveMatrix | ( | Dune::FieldMatrix< double, 6, 6 > & | C,
|  | bool | invers = false ) const

override virtual

Establishes the full constitutive matrix for this material.

Parameters

  [out] | C | The constitutive matrix
  [in] | invers | If true, set up the inverse matrix instead

Implements Opm::Elasticity::Material.

## getPar()

double Opm::Elasticity::OrthotropicSym::getPar | ( | int | ipar = 1 | ) | const

override virtual

Returns the ipar'th parameter describing this material.

Reimplemented from Opm::Elasticity::Material.

## numPar()

int Opm::Elasticity::OrthotropicSym::numPar | ( |  | ) | const

inline override virtual

Returns the number of parameters describing this material.

Implements Opm::Elasticity::Material.

## write()

std::ostream & Opm::Elasticity::OrthotropicSym::write | ( | std::ostream & | os | ) | const

override protected virtual

Prints the material properties to a stream.

Reimplemented from Opm::Elasticity::Material.

The documentation for this class was generated from the following files:

- opm/elasticity/materials.hh
- opm/elasticity/materials.cpp